
module band_scope (
   input rx_clock,
	input half_clock,
	input [15:0] reg_adc_data,
	input [11:0] rawRamReadAddr,
   output [15:0] rawRamOut,
	input rawRamReset,
   output reg rawRamReady
	);
	
	parameter RAW_RAM_SIZE = 4096;
	
	reg [11:0] rawRamWriteAddr;


	raw_ram rw(reg_adc_data, rawRamReadAddr, ~half_clock, rawRamWriteAddr, ~rx_clock, !rawRamReady, rawRamOut);
   
	always @(posedge rx_clock)
	begin
		if (rawRamReset)
		begin
			rawRamReady <= 0;
			rawRamWriteAddr <= 0;
		end
		else
		begin
			if (rawRamWriteAddr == (RAW_RAM_SIZE - 1)) rawRamReady <= 1;
			else rawRamWriteAddr <= rawRamWriteAddr + 1'd1;
		end
	end
	
	
endmodule
	