module ethernet_reset(		// Reset the bus on power up
	input slow_clock,
	output reset		// controller reset pin
	);
	
	
	reg [16:0] reset_timer = 17'd96000;  // time to release reset = 1 sec
	
	assign reset = (reset_timer == 0);
		
	always @(posedge slow_clock)
		if (reset_timer != 0) reset_timer <= reset_timer - 1'd1;

		
endmodule
