


module key_debounce(		// generate two delayed keys from the input key
	input clock, // 96kHz
	input key_dash,
	input key_dot,
	input ptt_input,
	output key_dash_db,
	output key_dot_db,
	output ptt_input_db
	);
	
	
	
	key_db dash_db (clock, key_dash,  key_dash_db);
	//
	key_db dot_db  (clock, key_dot,    key_dot_db);
	//
	key_db ptt_db (clock, ptt_input, ptt_input_db);
	
endmodule	


	
module key_db (
   input clock,
	input key_in,
	output reg key_out
);
	parameter dbtime = 10; // in msec
	
	reg [15:0] key_count;
   reg [3:0] key_history;

   always @ (posedge clock)
   begin
	   key_history <= {key_history[2:0], key_in};
		
	   if (key_history[3] != key_history[2])
		key_count <= 1'b0;
	   else if(key_count == dbtime * 96)
		key_out <= key_history[3];
	   else
		key_count <= key_count + 1'b1;
   end 	
endmodule	
	
	

