//
//  Key memory for delaying
// David Fainitski for the project Odyssey
//  2016



module key_delay (
   input clock, // 96k
	input reset,
	input [7:0] key_ctrl_delay ,
	input key_ctrl_valid,
	input key_out,
	output key_out_d,
	output reg PTT_delay
);

   reg [7:0] delay = 25;
	always @(posedge key_ctrl_valid) if (reset) delay <= key_ctrl_delay;
	
	reg [7:0] clk_cnt;
	reg [7:0] state;
	always @(posedge clock)
	begin
	   if(!reset)
	    begin	
		    clk_cnt <= 0;
			 wren <= 0;
			 wr_address <= 0;
			 state <= 0;
		end	 
		else
		case (state)
		0: if(clk_cnt != 96) clk_cnt <= clk_cnt + 1'd1;  // 1ms iteration
		   else 
			begin 
			   clk_cnt <= 1'd0; 
				wr_address <= wr_address + 1'd1;
				state <= 1; 
			end 
		1: begin wren <= 1; state <= 2; end
		2: begin wren <= 0; state <= 0; end
		endcase
	end
	
	
	reg [7:0] wr_address;
	wire [7:0] rd_address = wr_address - delay;
	reg wren;
	key_ram  k_ram (clock, key_out, rd_address, wr_address, wren, key_out_d);  // Loop buffer for the key delaying
   
	
	reg [15:0] delay_cnt;
	reg [2:0] delay_state;
	always @(posedge clock)
	begin
	   if(!reset) begin PTT_delay <= 0; delay_cnt <= 1'd0; delay_state <= 1'd0; end
		else 
		case (delay_state)
		0: if(!key_out) begin delay_cnt <= 1'd0; PTT_delay <= 0; end
		   else delay_state <= 1; 
		1: begin
		      PTT_delay <= 1;
	   	   if(delay_cnt != (delay+25) * 96) delay_cnt <= delay_cnt + 1'd1;
			   else delay_state <= 0;
			end
		endcase
	end
	
endmodule
	